//+------------------------------------------------------------------+
//|                                                 Victory05Exp.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
extern int
	mgod=2005;
	


extern double
   lots=0.1,
	stop=0.75;
extern int	
	per=24,
	zap=10,
	cbars=300,
	depth=15,
	deviation=5,
	backstep=3,
	d=3,
	dper=4,
	test=0,
	MM=1,
   StopLoss = 1000,
	TakeProfit = 25;
string
	candl;
	

bool
    ft=true;
int 
	cnt,pl,bsig,blok,
	j,kh,ssig,
	s,b,sumblk,
	os,ob;
	
	

	
double	
	stopor,zznul,	
	msum,ccione,
	mlot,zzone,delta,
	summa,bzzbig,impnul,
	zzold,szzbig,impone,
	fzz,cci,MaxH,MinL,
	szz;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
  	if (Year()!=mgod ) return(0);
  	
  	j=j+1;
  	
  	if(Minute()==0) j=0;
  	
  	if(ft) 
  	   {
  	      cnt=0;
  	
  	      while(fzz==szz) 
  	         {
  	            cnt=cnt+1;
  	            fzz=iCustom(Symbol(),0,"HistoZZ",cbars,depth,deviation,backstep,0,cnt-1);
	            szz=iCustom(Symbol(),0,"HistoZZ",cbars,depth,deviation,backstep,0,cnt); 
	            if(fzz!=szz) zzold=szz;
	         }
         ft=false;
       }
       
   if(MM==0) 
      {
         mlot=lots;
         kh=30;
      }
   if(MM==1)
      {
         kh=10;
         if (AccountFreeMargin( ) <10000 && AccountFreeMargin( ) >1500)  mlot=lots;
         if (AccountFreeMargin( ) >=10000) mlot=2*lots; 
         if (AccountFreeMargin( ) >=15000)  mlot=3*lots;
         if (AccountFreeMargin( ) >=20000)  mlot=4*lots;
         if (AccountFreeMargin( ) >=25000)  mlot=5*lots;
         if (AccountFreeMargin( ) >=30000)  mlot=6*lots;
         if (AccountFreeMargin( ) >=35000)  mlot=7*lots;
         if (AccountFreeMargin( ) >=40000)  mlot=8*lots;
         if (AccountFreeMargin( ) >=45000)  mlot=9*lots;
         if (AccountFreeMargin( ) >=50000)  mlot=10*lots;
         if (AccountFreeMargin( ) >=55000)  mlot=12*lots;
         if (AccountFreeMargin( ) >=60000)  mlot=15*lots;
     }
     
     

//----------------------------------------    ----------------------------------------


	s=0; b=0;
	os=0; ob=0;
	summa=0;	
	for (int cnt=0; cnt<OrdersTotal(); cnt++)
      {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if (OrderSymbol()==Symbol())
         {
			if ( OrderType()==OP_SELL || OrderType()==OP_BUY) 
				summa=summa+OrderProfit();
			if ( OrderType()==OP_SELL ) s++;
				
			if ( OrderType()==OP_BUY ) b++;
			
			if ( OrderType()==OP_SELLSTOP ) os++;
			if ( OrderType()==OP_BUYSTOP  ) ob++;
			}
		}

	if (s+b==0) 
		{ 
		msum=0;
		pl=0;
		stopor=0;sumblk=0;
		}
	
	if(summa>=500*mlot) sumblk=1;
	
	if(s+b==1 && sumblk==1)
      {
         if(msum<summa) msum=summa;
         stopor=NormalizeDouble((summa/msum),2);
         if(stopor<=stop) pl=1;
      }
      
      
   cci=iCCI(Symbol(),0,14,0,0);ccione=iCCI(Symbol(),0,14,0,1);
   zznul=iCustom(Symbol(),0,"HistoZZ",cbars,depth,deviation,backstep,0,0);
   zzone=iCustom(Symbol(),0,"HistoZZ",cbars,depth,deviation,backstep,0,1);
   bzzbig=iCustom(Symbol(),0,"ZZ Big",depth,deviation,backstep,0,1);
   szzbig=iCustom(Symbol(),0,"ZZ Big",depth,deviation,backstep,1,1);
   MaxH=iCustom(Symbol(),0,"Urovny",per,delta,0,0);
   MinL=iCustom(Symbol(),0,"Urovny",per,delta,1,0);
   impone=iCustom(Symbol(),0,"DayImpuls",dper,d,0,1);
   impnul=iCustom(Symbol(),0,"DayImpuls",dper,d,0,0);
   
   delta=MathRound((MathAbs(Close[0]-zzold))/Point);
   if (zzold==0) delta=0;

   if (zznul>0 && zzone>0 && zzone>zznul && impone<-30 && impone<impnul) 
      {
         ObjectCreate( "arrow", OBJ_ARROW, 0, Time[0], Low[0]-5*Point); 
         ObjectSet( "arrow",OBJPROP_ARROWCODE,241);
      }
   if (zznul>0 && zzone>0 && zzone<zznul && impone>30 && impone>impnul)  
      {
         ObjectCreate( "arrow", OBJ_ARROW, 0, Time[0], High[0]+5*Point); 
         ObjectSet( "arrow",OBJPROP_ARROWCODE,242);
      
      }
  
   if (zznul!=0 && zzone!=0 && zzone!=zznul)  zzold=zzone;
    if(zzold<0)  zzold=0;
    
   if (Close[0]>Open[0]) candl="White";
   if (Close[0]<Open[0]) candl="Black";
   if (Close[0]==Open[0]) candl="Dodjy";


if(bzzbig!=0 && szzbig==0 && bzzbig<zzold && impnul<=-30 && impone<impnul && Close[0]>bzzbig&& ccione<=-150 && cci<0 && Close[0]<=MinL) bsig=1;
 
if(szzbig!=0 && bzzbig==0 && szzbig>zzold && impnul>=30 && impone>impnul && Close[0]<szzbig && ccione>=150 && cci>0 && Close[0]>=MaxH) ssig=1;

if (s+b>0) {  bsig=0;ssig=0;}

//----------------------------------------    -------------------------------------

if (s+b==2 && summa>500*mlot) pl=1; 
if (summa>mlot*350 && s+b==1) pl=1;

if (pl==1) {
for (cnt=0; cnt<OrdersTotal(); cnt++)
			{
			OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
			if (OrderSymbol()==Symbol())
				{
				if (OrderType()==OP_SELL) 
					{
				
					OrderClose(OrderTicket(),OrderLots(),Ask,5,Red);
					return(0);
					}
				
				if (OrderType()==OP_BUY) 
					{
					
					OrderClose(OrderTicket(),OrderLots(),Bid,5,Red);
					return(0);
					}
				}
			}
		}

//----------------------------------------------- ----------------------------------------------

if (test==1)
Print("Data: ",Month()," ",Day(),"  Time: ",Hour()," ",Minute(),"  SZZ=",szzbig,"  BZZ=",bzzbig,"  OldZZ=",zzold,"  DPr=",delta,
      "  0Imp=",MathRound(impnul),"  0CCI=",MathRound(cci),"  Pl=",pl,"  Stpr=",stopor,"  MaxSum=",MathRound(msum),
      "  Profit=",MathRound(summa));
      
if (test==0)
Comment("Data: ",Month()," ",Day(),"  Time: ",Hour()," ",Minute(),"   JInd=",j,"\n",
        "SZZBig=",szzbig,"  BZZBig=",bzzbig,"  ZZOld=",zzold,"  DPr=",delta,"  1Imp=",MathRound(impone),
        "  0Imp=",MathRound(impnul),"  1CCI=",MathRound(ccione),"  0CCI=",MathRound(cci),"  Pl=",pl,"  Stpr=",stopor,"  Blk=",blok,
        "  MaxSum=",MathRound(msum),"  Candl_0=",candl,"  Profit=",MathRound(summa));


//------------------------------------ -   --------------------------------------

if (s+b==1 && os+ob==0 && blok==0)
   {
      if ((b==1 && s==0 && os==0 && cci>300 && summa<-300*mlot)|| 
    (b==0 && s==1 && os==0 && cci>100 && impone>impnul && impnul>0 && summa>=20)) 
      {
         Alert(" -  : ",Bid());blok=1; 
         OrderSend(Symbol(),OP_SELL,kh*mlot,Bid(),3,Bid()+StopLoss*Point,Bid()-TakeProfit*Point,"",0,0,Violet);
         return(0);
      } 
   if ((s==1 && b==0 && ob==0 && cci<-300 && summa<-300*mlot)||
    (s==0 && b==1 && ob==0 && cci<-100 && impone<impnul && impnul<0 && summa>=20))
      {
         Alert(" -  : ",Ask());blok=1;
         OrderSend(Symbol(),kh*mlot,Ask(),3,Ask()-StopLoss*Point,Ask()+TakeProfit*Point,"",0,0,Gold);
         return(0);
      }
  }

//-------------------------------------------------- ----------------------------------------------------

if(s+b==0 && os+ob==0) 
   {
      if(ssig==1)
         {
            Alert("     : ",Bid());
            OrderSend(Symbol(),OP_SELL,mlot,Bid(),3,Bid+StopLoss*Point,Bid-TakeProfit*Point,"",0,0,Violet);
            blok=0;return(0);
         }
      if(bsig==1)
         {
            Alert("     : ",Ask());
            OrderSend(Symbol(),OP_BUY,mlot,Ask(),3,Ask-StopLoss*Point,Ask+TakeProfit*Point,"",0,0,Gold);
            blok=0;
            return(0);
         }
   }




   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+