//+------------------------------------------------------------------+
//|                                                      HistoZZ.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 1

extern int cbars=500;
extern int depth=15;
extern int deviation=5;
extern int backstep=3;


int 
   shift;

double
   zz0,zzlast;

double ExtMapBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
IndicatorBuffers(1);
SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,EMPTY,Red);

SetIndexBuffer(0,ExtMapBuffer);


//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   
   for(shift=Bars-1;shift>=0;shift--)
      {
         zz0=iCustom(Symbol(),0,"ZigZag",depth,deviation,backstep,0,shift);
          if (zz0 > 0)  zzlast = zz0;
         ExtMapBuffer[shift]=zzlast;
        
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+