//+------------------------------------------------------------------+
//|                                                       urovni.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 2

extern int per=60;
extern int delta=10;

int 
   shift;

double
   HMa,LMa;

double ExtMapBuffer[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
IndicatorBuffers(2);
SetIndexStyle(0,DRAW_LINE,EMPTY,EMPTY,GreenYellow);
SetIndexStyle(1,DRAW_LINE,EMPTY,EMPTY,Gold);
SetIndexBuffer(0,ExtMapBuffer);
SetIndexBuffer(1,ExtMapBuffer2);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   
   for(shift=Bars-1;shift>=0;shift--)
      {
         HMa=iMA(Symbol(),0,per,0,MODE_EMA,PRICE_HIGH,shift)+delta*Point;
         LMa=iMA(Symbol(),0,per,0,MODE_EMA,PRICE_LOW,shift)-delta*Point;
         ExtMapBuffer[shift]=HMa;
         ExtMapBuffer2[shift]=LMa;
      }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+